// PAC archive file extraction tool (specifically for use with Rurouni Kenshin Kaisen psp archives)
// IQ_132 - http://neosource.1emu.net
// License - http://creativecommons.org/licenses/by-nc/3.0/

// There are some unknown bits in the structure. One seems to be flags of some sort??

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define getword(z)   (((z)[1] << 8) | ((z)[0] << 0))
#define getlong(z)   (((z)[3] << 24) | ((z)[2] << 16) | ((z)[1] << 8) | ((z)[0] << 0))

int main(int argc, char **argv)
{
	int i,j;
	char output[128], foutput[256];

	if (argc < 2) {
		printf ("File name:\n");
		gets(output);
	} else {
		strcpy (output, argv[1]);
	}

	FILE *fa = fopen(output, "rb");
	fseek (fa, 0, SEEK_END);
	int len = ftell (fa);
	rewind (fa);

	unsigned char *src = (unsigned char*)malloc(len);

	fread (src, len, 1, fa);
	fclose (fa);

	// remove '.' from archive name so that it can be used as a directory name
	for (i = 0; i < strlen(output); i++) {
		if (output[i] == 0x2e /*.*/) output[i] = '_';
	}

	// create a directory with the title of the original archive (internal name)
	sprintf (foutput, "mkdir %s", output);
	system (foutput);

	{
		if (src[0] != 'a' || src[1] != 'd' || src[2] != 'd' || src[3] != 0) {
			printf ("invalid archive type!\n");
			return 1;
		}

		unsigned int unknown0 = getlong(src + 0x004);
		unsigned int unknown1 = getlong(src + 0x008);
		unsigned int unknown2 = getlong(src + 0x00c);

		unsigned int file_num = getlong(src + 0x010); // number of files in archive
		unsigned int arc_size = getlong(src + 0x014); // total archive size

		int i;
		for (i = 0; i < file_num; i++)
		{
			char name[256]; // more than necessary, hopefully...

			unsigned char *offs = src + 0x020 + i * 0x20;

			unsigned int data_offset = getlong(offs + 0x00);
			unsigned int data_length = getlong(offs + 0x04);
			unsigned int data_fflags = getlong(offs + 0x0c); // flags of some sort????
			unsigned int data_flname = getlong(offs + 0x10);

			for (j = 0; j < 256; j++) {
				name[j] = src[j + data_flname];
				if (name[j] == 0) break;
			}

			printf ("%s, %8.8x, %8.8x, %8.8x %8.8x\n", name, data_offset, data_length, data_fflags, data_flname);

			sprintf(foutput, "%s//%s", output, name);

			printf ("%s\n", foutput);

			fa = fopen(foutput, "wb");
			fwrite (src + data_offset, data_length, 1, fa);
			fclose (fa);
		}
	}

	free (src);
}
